<template>
    <el-collapse v-model="activeTabs">
        <el-collapse-item v-for="(keyObj, keyName) in sections" :key="keyName" :name="keyName">
            <template v-slot:title>{{keyObj.title}}</template>
            <slot :name="keyName" :section="keyObj" :id="keyName"></slot>
        </el-collapse-item>
    </el-collapse>
</template>

<script>
import { mapState } from 'vuex';

export default {
    props: {
        /** all collapse sections */
        sections: {
            type: Object,
            required: false,
        },
        /** opened collapse sections */
        value: {
            type: Array,
            required: false,
        },
    },
    created() {
        this.$store.commit('updateActiveSections', this.value);
    },
    watch: {
        invalidIdToScroll(newVal) {
            if (newVal) {
                this.openInvalidSection(newVal);
            }
        },
    },
    computed: {
        activeTabs: {
            get() {
                return this.value;
            },
            set(newVal) {
                this.$store.commit('updateActiveSections', newVal);
                this.$emit('input', newVal);
            },
        },
        ...mapState({
            invalidIdToScroll: state => state.validation.invalidIdToScroll,
        }),
    },
    methods: {
        /**
         * Handler for opening tabs that have invalid validation parametres
         * @param {String} - UID of the parameter
         */
        openInvalidSection(uid) {
            const findInObj = (obj, str) => obj && Object.keys(obj).find(key => str.includes(key));

            const collapseId = Object.entries(this.sections).reduce((acc, [k, v]) => {
                if (uid.includes(k) || findInObj(v.subsections, uid) || findInObj(v.data, uid)) {
                    return k;
                }
                return acc;
            }, '');
            if (collapseId && !this.activeTabs.includes(collapseId)) {
                this.activeTabs = [...this.activeTabs, collapseId];
            }
        },
    },
};
</script>

<style lang="stylus" scoped>
>>> .el-collapse-item__header
        background-color: $bg_light_gray
        font-size: 1.6rem;
        font-weight: bolder
        color: $title_blue
        padding: 0 1rem

>>> .el-icon-d-arrow-left
    font-weight: 600

>>> .el-collapse-item__arrow
    line-height: 4.8rem

>>> .is-active
    background-color: #fff

>>> .el-collapse-item__content
    font-size: 1.6rem
    margin: .5rem 1rem

</style>
